<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Danh sách người dùng</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.4/css/all.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <link rel="stylesheet" href="plugins/select2/css/select2.min.css">
    <link rel="stylesheet" href="plugins/select2-bootstrap4-theme/select2-bootstrap4.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <style>
        .pointer {
            cursor: pointer;
        }
    </style>
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">User list</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="#" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    UI Controls
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>

                        </li>
                        <li class="nav-item">
                            <a href="index.html" class="nav-link active">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    Quản lí bảng điểm
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">

            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">Quản lí bảng điểm</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Grade</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <section class="content">
                <div class="container">
                    <div class="row">
                        <div class="col-sm-12 text-center">
                            <h4>Lịch sử học tập</h4>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-12">
                            <p><b>Thông tin student</b></p>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-sm-6">
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Student</label>
                                        <select class="form-control select2" style="width: 100%;" id="select-student">
                                            <option value="0">All</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="col-sm-6">
                            <div class="row">
                                <div class="col-md-12">
                                    <div class="form-group">
                                        <label>Subject</label>
                                        <select class="form-control select2" style="width: 100%;" id="select-subject">
                                            <option value="0">All</option>
                                        </select>
                                    </div>
                                </div>
                            </div>
                        </div>

                    </div><br><br>
                    <div class="row">
                        <div class="col-sm-6">
                            <button class="btn btn-success" id="btn-filter">Lọc dữ liệu</button>
                        </div>
                        <div class="col-sm-6">
                            <button class="btn btn-info" id="btn-add-grade">Thêm Grade</button>
                        </div>
                    </div><br><br>
                    <div class="row">
                        <div class="col-sm-12">
                            <table class="table table-bordered table-striped table-hover" id="table-student">
                                <thead>
                                    <tr>
                                        <th>STT</th>
                                        <th>Student</th>
                                        <th>Môn học</th>
                                        <th>Điểm</th>
                                        <th>Ngày thi</th>
                                        <th>Action</th>
                                    </tr>
                                </thead>
                                <tbody></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </section>
            <!-- /.content -->
        </div>
        <!-- /.content-wrapper -->

        <footer class="main-footer">
            <strong>Copyright &copy; 2022 Devcamp.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>

    <!-- Add Grade modal -->
    <div>
        <div id="insert-grade-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Thêm Grade</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-voucher-code">studentId</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control select2" style="width: 100%;" id="select-studentid">
                                        <option value="0">Chọn sinh viên</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">subjectId</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control select2" style="width: 100%;" id="select-subjectid">
                                        <option value="0">Chọn môn học</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">grade</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-grade" name="discount" placeholder="..." class="form-control"
                                        type="number">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">examDate</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-examdate" name="discount" placeholder="..." class="form-control"
                                        type="date">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-insert-grade">Insert Grade</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Update Grade modal -->
    <div>
        <div id="update-grade-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Update Grade</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <form>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-voucher-code">studentId</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control select2" style="width: 100%;"
                                        id="select-update-studentid">
                                        <option value="0">Chọn sinh viên</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">subjectId</label>
                                </div>
                                <div class="col-sm-8">
                                    <select class="form-control select2" style="width: 100%;"
                                        id="select-update-subjectid">
                                        <option value="0">Chọn môn học</option>
                                    </select>
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">grade</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-grade" name="discount" placeholder="..." class="form-control"
                                        type="number">
                                </div>
                            </div>
                            <div class="row form-group">
                                <div class="col-sm-4">
                                    <label for="input-create-discount">examDate</label>
                                </div>
                                <div class="col-sm-8">
                                    <input id="inp-update-examdate" name="discount" placeholder="..."
                                        class="form-control" type="date">
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">Cancel</button>
                        <button class="btn btn-primary" id="btn-update-grade">Update Grade</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- Delete Grade modal -->
    <div>
        <div class="modal fade" tabindex="-1" id="delete-grade-modal">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <h5 class="modal-title" id="h5-modal-title">Grade Delete Confirmation</h5>
                        <button class="close" data-dismiss="modal">&times;</button>
                    </div>
                    <div class="modal-body">
                        <label>Bạn có chắc chắn muốn xóa grade này không?</label>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-danger" id="btn-confirm-delete-grade">Confirm</button>
                        <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="plugins/select2/js/select2.full.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>

    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</body>

<script>
    $('.select2').select2({
        theme: 'bootstrap4'
    });

    var gNameCols = ["stt", "studentId", "subjectId", "grade", "examDate", "action"];

    const gSTT_COL = 0;
    const gSTUDENT_COL = 1;
    const gSUBJECT_COL = 2;
    const gGRADE_COL = 3;
    const gEXAMDATE_COL = 4;
    const gACTION_COL = 5;
    var gStt = 1;
    var gStudents = null;
    var gSubjects = null;
    var gGrades = null;
    var gStudentName = null;
    var gGradeId = null;


    var gDataTable = $("#table-student").DataTable({
        columns: [
            { data: gNameCols[gSTT_COL] },
            { data: gNameCols[gSTUDENT_COL] },
            { data: gNameCols[gSUBJECT_COL] },
            { data: gNameCols[gGRADE_COL] },
            { data: gNameCols[gEXAMDATE_COL] },
            { data: gNameCols[gACTION_COL] }
        ],

        columnDefs: [
            {
                targets: gSTT_COL,
                render: function () {
                    return gStt++;
                }
            },
            {
                targets: gSTUDENT_COL,
                render: getStudentNamebyStudentId
            },
            {
                targets: gSUBJECT_COL,
                render: getSubjectNamebySubjectId
            },
            {
                targets: gACTION_COL,
                defaultContent: `
          <i class="fas fa-edit text-success pointer" data-toggle="tooltip" title="Edit"></i>
          <i class="fas fa-trash-alt text-danger pointer" data-toggle="tooltip" title="Delete"></i>
        `
            }
        ]

    })

    $(document).ready(function () {
        getStudentList();
        getSubjectList();
        loadGrade();
    });

    $(document).on("click", "#btn-filter", function () {
        onBtnFilterClick();
    });

    $(document).on("click", "#btn-add-grade", function () {
        onBtnAddGradeClick();
    });

    $(document).on("click", "#btn-insert-grade", function () {
        onBtnAddGradeInfoClick();
    });

    $(document).on("click", ".fa-edit", function () {
        $("#update-grade-modal").modal("show");
        onEditClick(this);
    });

    $(document).on("click", "#btn-update-grade", function () {
        onBtnUpdateGrade();
    });

    $(document).on("click", ".fa-trash-alt", function () {
        $("#delete-grade-modal").modal("show");
        var vRowData = gDataTable.row($(this).closest("tr")).data();
        gGradeId = vRowData.id;

    });

    $(document).on("click", "#btn-confirm-delete-grade", function () {
        deleteGrade(gGradeId);
    })

    function deleteGrade(paramGradeId) {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/grades/" + paramGradeId,
            type: "DELETE",
            success: function () {
                alert("delete điểm thành công");
                location.reload();
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function onBtnUpdateGrade() {
        var vGradeObjRequest = {
            studentId: "",
            subjectId: "",
            grade: "",
            examDate: ""
        };

        getGradeUpdateData(vGradeObjRequest);
        var vValidate = validateData(vGradeObjRequest);
        if (vValidate) {
            updateGrade(vGradeObjRequest);
        }

    }

    function getGradeUpdateData(paramGrade) {
        paramGrade.studentId = $("#select-update-studentid").val();
        paramGrade.subjectId = $("#select-update-subjectid").val();
        paramGrade.grade = $("#inp-update-grade").val();
        paramGrade.examDate = $("#inp-update-examdate").val();
    }

    function updateGrade(paramGrade) {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/grades/" + gGradeId,
            type: "PUT",
            contentType: "application/json",
            data: JSON.stringify(paramGrade),
            success: function () {
                alert("update điểm thành công");
                location.reload();
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function onEditClick(paramElement) {
        var vRowData = gDataTable.row($(paramElement).closest("tr")).data();
        gGradeId = vRowData.id
        getGradeById(gGradeId);
    }

    function getGradeById(paramGradeId) {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/grades/" + paramGradeId,
            type: "GET",
            async: false,
            success: function (grade) {
                loadGradeToUpdate(grade);
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function loadGradeToUpdate(paramGrade) {
        console.log(paramGrade);
        $("#select-update-studentid").select2("val", paramGrade.studentId.toString());
        $("#select-update-subjectid").select2("val", paramGrade.subjectId.toString());
        $("#inp-update-grade").val(paramGrade.grade);
        const date = paramGrade.examDate;
        const [month, day, year] = date.split('/');
        const result = [year, month, day].join('-');
        console.log(result);
        $("#inp-update-examdate").val(result);
    }

    function onBtnAddGradeInfoClick() {
        var vGradeObjRequest = {
            studentId: "",
            subjectId: "",
            grade: "",
            examDate: ""
        };

        getGradeData(vGradeObjRequest);
        var vValidate = validateData(vGradeObjRequest);
        if (vValidate) {
            createGrade(vGradeObjRequest);
        }
    }

    function createGrade(paramGrade) {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/grades",
            type: "POST",
            contentType: "application/json",
            data: JSON.stringify(paramGrade),
            success: function () {
                alert("nhập điểm thành công");
                location.reload();
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function validateData(paramGrade) {
        if (paramGrade.studentId == 0) {
            alert("Vui lòng chọn học sinh");
            return false;
        }
        if (paramGrade.subjectId == 0) {
            alert("Vui lòng chọn môn học");
            return false;
        }
        if (paramGrade.grade == "") {
            alert("Vui lòng nhập điểm");
            return false;
        }
        if (paramGrade.grade < 0 || paramGrade.grade > 10) {
            alert("Điểm không hợp lệ");
            return false;
        }
        if (paramGrade.examDate == "") {
            alert("Vui lòng nhập ngày thi");
            return false;
        }
        return true;
    }

    function getGradeData(paramGrade) {
        paramGrade.studentId = $("#select-studentid").val();
        paramGrade.subjectId = $("#select-subjectid").val();
        paramGrade.grade = $("#inp-grade").val();
        paramGrade.examDate = $("#inp-examdate").val();
    }

    function onBtnFilterClick() {
        var vStudent = {
            firstname: "",
            subject: ""
        }

        getFilterData(vStudent);

        filterStudent(vStudent);
    }

    function getFilterData(paramStudent) {
        paramStudent.firstname = $("#select-student").val();
        paramStudent.subject = $("#select-subject").val();

    }

    function filterStudent(paramStudent) {
        var vStudentResult = [];
        vStudentResult = gGrades.filter(function (paramGrade) {
            return ((paramGrade.studentId == paramStudent.firstname && paramGrade.subjectId == paramStudent.subject)
                || (paramStudent.firstname == 0 && paramStudent.subject == 0)
                || (paramGrade.studentId == paramStudent.firstname && paramStudent.subject == 0)
                || (paramGrade.subjectId == paramStudent.subject && paramStudent.firstname == 0));
        });
        if (vStudentResult.length == 0) {
            alert("không tìm thấy kết quả");
        }
        else {
            loadStudentToTable(vStudentResult);
        }
    }


    function onBtnAddGradeClick() {
        $("#insert-grade-modal").modal("show");

    }

    function getStudentId() {
        for (var student of gStudents) {
            $("<option>", { text: student.username, value: student.id }).appendTo($("#select-studentid"));
        }
    }

    function getUpdateStudentId() {
        for (var student of gStudents) {
            $("<option>", { text: student.username, value: student.id }).appendTo($("#select-update-studentid"));
        }
    }

    function getSubjectId() {
        for (var subject of gSubjects) {
            $("<option>", { text: subject.subjectName, value: subject.id }).appendTo($("#select-subjectid"));
        }
    }

    function getUpdateSubjectId() {
        for (var subject of gSubjects) {
            $("<option>", { text: subject.subjectName, value: subject.id }).appendTo($("#select-update-subjectid"));
        }
    }

    function loadGrade() {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/grades",
            type: "GET",
            async: false,
            success: function (grade) {
                gGrades = grade;
                loadStudentToTable(grade);
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function loadStudentToTable(paramGrade) {
        gStt = 1
        gDataTable.clear();
        gDataTable.rows.add(paramGrade);
        gDataTable.draw();
    }

    function getStudentNamebyStudentId(paramStudentId) {
        var vStudentname = null;
        for (var bI = 0; bI < gStudents.length; bI++) {
            if (gStudents[bI].id == paramStudentId) {
                vStudentname = gStudents[bI].username;
            }
        }
        return vStudentname;
    }

    function getSubjectNamebySubjectId(paramSubjectId) {
        var vSubjectname = null;
        for (var bI = 0; bI < gSubjects.length; bI++) {
            if (gSubjects[bI].id == paramSubjectId) {
                vSubjectname = gSubjects[bI].subjectName;
            }
        }
        return vSubjectname;
    }

    function getStudentList() {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/students",
            type: "GET",
            async: false,
            success: function (student) {
                loadDataToStudentSelect(student);
                gStudents = student;
                getStudentId();
                getUpdateStudentId();
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function getSubjectList() {
        $.ajax({
            url: "https://62454a477701ec8f724fb923.mockapi.io/api/v1/" + "/subjects",
            type: "GET",
            async: false,
            success: function (subject) {
                loadDataToSubjectSelect(subject);
                gSubjects = subject;
                getSubjectId();
                getUpdateSubjectId();
            },
            error: function () {
                alert("fail");
            }
        })
    }

    function loadDataToStudentSelect(paramStudent) {
        for (var student of paramStudent) {
            $("<option>", { text: student.username, value: student.id }).appendTo($("#select-student"));
        }
    }

    function loadDataToSubjectSelect(paramSubject) {
        for (var subject of paramSubject) {
            $("<option>", { text: subject.subjectName, value: subject.id }).appendTo($("#select-subject"));
        }
    }
</script>

</html>